; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS:
;-------------------------------------------------------------------------------
; ZHLER (0...47)																
	inc ZAEHLER
	cpi ZAEHLER,(47+1)
	brlo RDS_Z_FERTIG
	clr ZAEHLER
RDS_Z_FERTIG:
;-------------------------------------------------------------------------------
	tst INTERRUPTAUFRUF
	breq RDS_START_KONTROLLE_FERTIG
RDS_ERROR:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	ldi temp,20
	CLI	; Interrupts sperren	
RDS_ERROR_s:
	cbi (LED_ROTC_PORT),(LED_ROTC_PIN_NR)		; ROT(C)an	
	rcall wait_100ms
	sbi (LED_ROTC_PORT),(LED_ROTC_PIN_NR)		; ROT(C)aus	
	rcall wait_100ms
	dec temp
	brne RDS_ERROR_s
	SEI	; Interrupts freigeben	
RDS_START_KONTROLLE_FERTIG:
;-------------------------------------------------------------------------------
; START nach Interrupt-Aufruf													
	sbi (AUSGANG_TEST_PORT),(AUSGANG_TEST_PIN_NR)			; auf HIGH		
	SLEEP
	cbi (AUSGANG_TEST_PORT),(AUSGANG_TEST_PIN_NR)			; auf LOW		
	clr INTERRUPTAUFRUF
;-------------------------------------------------------------------------------
; PHASENSCHIEBER																
	tst PHASE
	breq RDS_PHASE_FERTIG
	cpi PHASE,50
	brlo RDS_PHASE_RUN
	clr PHASE
	rjmp RDS_PHASE_FERTIG
RDS_PHASE_RUN:
	mov temp,PHASE
RDS_TEST:
	dec temp
	brne RDS_TEST
RDS_PHASE_FERTIG:
;-------------------------------------------------------------------------------
; DEMODULATOR																	
	; SAMPLING				
	sbic (EINGANGB_PIN),(EINGANGB_PIN_NR)
	rjmp RDS_DEMODULATOR_L
RDS_DEMODULATOR_H:
	sbi (AUSGANG_DEMODULATORA_PORT),(AUSGANG_DEMODULATORA_PIN_NR)			; auf HIGH		
	; ANTI-JITTER			
	cpi ANTIJITTER,(3)	; 3
	breq RDS_DEMODULATOR_H_w
	inc ANTIJITTER
	rjmp RDS_DEMODULATOR_FERTIG
RDS_DEMODULATOR_H_w:
	sbi (AUSGANG_DEMODULATORB_PORT),(AUSGANG_DEMODULATORB_PIN_NR)			; auf HIGH		
	mov SAMPLING,VOLL
	rjmp RDS_DEMODULATOR_FERTIG
RDS_DEMODULATOR_L:
	cbi (AUSGANG_DEMODULATORA_PORT),(AUSGANG_DEMODULATORA_PIN_NR)			; auf LOW		
	; ANTI-JITTER			
	tst ANTIJITTER
	breq RDS_DEMODULATOR_L_w
	dec  ANTIJITTER
	rjmp RDS_DEMODULATOR_FERTIG
RDS_DEMODULATOR_L_w:
	clr SAMPLING
	cbi (AUSGANG_DEMODULATORB_PORT),(AUSGANG_DEMODULATORB_PIN_NR)			; auf LOW		
RDS_DEMODULATOR_FERTIG:
;-------------------------------------------------------------------------------
; PHASENWECHSEL Erkennung														
	cp SAMPLING,SAMPLING_OLD  
	breq RDS_PHASENWECHSEL_w
;-------------------------------------------------------------------------------
	cpi ZAEHLER,(3+1)				;  0... 3	
	brlo RDS_PHASENWECHSEL_ZONE_A
	cpi ZAEHLER,(11+1)				;  4...11	
	brlo RDS_PHASENWECHSEL_ZONE_B
	cpi ZAEHLER,(19+1)				; 12...19	
	brlo RDS_PHASENWECHSEL_ZONE_C
	cpi ZAEHLER,(27+1)				; 20...27	
	brlo RDS_PHASENWECHSEL_ZONE_D
	cpi ZAEHLER,(35+1)				; 28...35	
	brlo RDS_PHASENWECHSEL_ZONE_E
	cpi ZAEHLER,(43+1)				; 36...43	
	brlo RDS_PHASENWECHSEL_ZONE_F
RDS_PHASENWECHSEL_ZONE_A:
	inc ZONE_A
	rjmp RDS_PHASENWECHSEL_w
RDS_PHASENWECHSEL_ZONE_B:
	inc ZONE_B
	rjmp RDS_PHASENWECHSEL_w
RDS_PHASENWECHSEL_ZONE_C:
	inc ZONE_C
	rjmp RDS_PHASENWECHSEL_w
RDS_PHASENWECHSEL_ZONE_D:
	inc ZONE_D
	rjmp RDS_PHASENWECHSEL_w
RDS_PHASENWECHSEL_ZONE_E:
	inc ZONE_E
	rjmp RDS_PHASENWECHSEL_w
RDS_PHASENWECHSEL_ZONE_F:
	inc ZONE_F
RDS_PHASENWECHSEL_w:
	mov SAMPLING_OLD,SAMPLING	; OLD merken	
RDS_PHASENWECHSEL_FERTIG:
;-------------------------------------------------------------------------------
; SAMPLING-A																	
	cpi ZAEHLER,11
	brne RDS_SAMPLING_A_FERTIG
	mov SAMPLING_A, SAMPLING
RDS_SAMPLING_A_FERTIG:
;-------------------------------------------------------------------------------
; TAKT generieren(HIGH)															
	cpi ZAEHLER,23
	brne RDS_TAKT_HIGH_FERTIG
	sbi (AUSGANG_TAKT_PORT),(AUSGANG_TAKT_PIN_NR)			; auf HIGH			
RDS_TAKT_HIGH_FERTIG:
;-------------------------------------------------------------------------------
; DATA-Korrektur																
; nach jedem Biphsaesymbol muss sich die Phase ndern							
	cpi ZAEHLER,35
	brne RDS_DATA_KORREKTUR_FERTIG
	; Vergleich SAMPLING-A / SAMPLING-B		
	cp SAMPLING_A, SAMPLING_B  
	brne RDS_DATA_KORREKTUR_OK
	; KOrrektur (SAMPLING-A invertieren)	
	mov SAMPLING_A, SAMPLING_B 
	com SAMPLING_A
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)						; ROT  an		
	; PHASE Hilfszaehler	
	dec PHASE_HILFSZAEHLER
	brne RDS_DATA_KORREKTUR_FERTIG
	; PHASE+1					
	inc PHASE
	ldi PHASE_HILFSZAEHLER,10
	cbi (LED_ROTA_PORT),(LED_ROTA_PIN_NR)		; ROT(A)an	
	rjmp RDS_DATA_KORREKTUR_FERTIG
RDS_DATA_KORREKTUR_OK:
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)						; ROT  aus		
	sbi (LED_ROTA_PORT),(LED_ROTA_PIN_NR)		; ROT(A)aus	
RDS_DATA_KORREKTUR_FERTIG:
;-------------------------------------------------------------------------------
; DATA																			
	cpi ZAEHLER,36
	brne RDS_DATA_FERTIG
	mov SAMPLING_B,SAMPLING
	; Vergleich SAMPLING-A / SAMPLING-B
	cp SAMPLING_A, SAMPLING_B  
	brne RDS_DATA__L	
RDS_DATA__H:
	sbi (AUSGANG_DATA_PORT),(AUSGANG_DATA_PIN_NR)			; auf HIGH	
	rjmp RDS_DATA_FERTIG
RDS_DATA__L:
	cbi (AUSGANG_DATA_PORT),(AUSGANG_DATA_PIN_NR)			; auf LOW		
RDS_DATA_FERTIG:
;-------------------------------------------------------------------------------
; TAKT (LOW)																	
	cpi ZAEHLER,47
	brne RDS_TAKT_LOW_FERTIG
	cbi (AUSGANG_TAKT_PORT),(AUSGANG_TAKT_PIN_NR)			; auf LOW			
RDS_TAKT_LOW_FERTIG:
;-------------------------------------------------------------------------------
; TAKT-KORREKTUR																
;																																					
; |00|01|02|03|04|05|06|07|08|09|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31|32|33|34|35|36|37|38|39|40|41|42|43|44|45|46|47|	
; |  ZONE-A   |       ZONE-B          |       ZONE-C          |       ZONE-D          |       ZONE-E          |       ZONE-F          |  ZONE-A   |	
	cpi ZAEHLER,47
	brne RDS_TAKT_KORREKTUR_FERTIG
	; vergleich	
	cp ZONE_A,VOLL					; ZONE-A
	breq RDS_TAKT_KORREKTUR_OK
	cp ZONE_B,VOLL					; ZONE-B
	breq RDS_TAKT_KORREKTUR_MINUS
	cp ZONE_C,VOLL					; ZONE-C
	breq RDS_TAKT_KORREKTUR_MINUS
	cp ZONE_D,VOLL					; ZONE-D
	breq RDS_TAKT_KORREKTUR_PLUS
	cp ZONE_E,VOLL					; ZONE-E
	breq RDS_TAKT_KORREKTUR_PLUS
	cp ZONE_F,VOLL					; ZONE-F
	breq RDS_TAKT_KORREKTUR_PLUS
	rjmp RDS_TAKT_KORREKTUR_FERTIG

RDS_TAKT_KORREKTUR_MINUS:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	ldi ZAEHLER,46 
	rjmp RDS_TAKT_KORREKTUR_CLEAR
RDS_TAKT_KORREKTUR_PLUS:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	ldi ZAEHLER,1 
	rjmp RDS_TAKT_KORREKTUR_CLEAR
RDS_TAKT_KORREKTUR_OK:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
RDS_TAKT_KORREKTUR_CLEAR:
	clr ZONE_A
	clr ZONE_B
	clr ZONE_C
	clr ZONE_D
	clr ZONE_E
	clr ZONE_F
RDS_TAKT_KORREKTUR_FERTIG:
;-------------------------------------------------------------------------------
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
