;												
; RDS-Rohdatendecoder (Version-2)				
; Bernhard.Erfurt@gmx.de						
; 31.03.2014									
;												


; Anschlussbelegung PINS						
;												
; PB0 ==> OUT (TAKT)							
; PB1 ==> OUT (DATA)							
; PB2 ==> 										
; PB3 ==> OUT CTC2								
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> OUT DEMODULATOR-A						
; PC1 ==> OUT DEMODULATOR_B (ANTIJITTER)		
; PC2 ==> OUT TEST								
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> IN 57kHZ SIGNAL						
; PD3 ==> IN RDS SIGNAL							
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								

; ATmega8 										
.include "m8def.inc"
; TIMER-WERTE									
.equ TIMER2CTC						= 0		;   139=57.143kHz			
; EINGANG-A (57kHz)								
.equ EINGANGA_PIN_NR				= 2
.equ EINGANGA_PIN					= PIND
.equ EINGANGA_DDR					= DDRD
.equ EINGANGA_PORT					= PORTD
; EINGANG-B (RDS)								
.equ EINGANGB_PIN_NR				= 3
.equ EINGANGB_PIN					= PIND
.equ EINGANGB_DDR					= DDRD
.equ EINGANGB_PORT					= PORTD
; AUSGANG (TAKT)								
.equ AUSGANG_TAKT_PIN_NR			= 0
.equ AUSGANG_TAKT_PIN				= PINB
.equ AUSGANG_TAKT_DDR				= DDRB
.equ AUSGANG_TAKT_PORT				= PORTB
; AUSGANG (DATA)								
.equ AUSGANG_DATA_PIN_NR			= 1
.equ AUSGANG_DATA_DDR				= DDRB
.equ AUSGANG_DATA_PORT				= PORTB
; AUSGANG-CTC2 (CTC-Timer2)					
.equ AUSGANG_CTC2_PIN_NR			= 3
.equ AUSGANG_CTC2_PIN				= PINB
.equ AUSGANG_CTC2_DDR				= DDRB
.equ AUSGANG_CTC2_PORT				= PORTB
; AUSGANG (DEMODULATOR-A)						
.equ AUSGANG_DEMODULATORA_PIN_NR	= 0
.equ AUSGANG_DEMODULATORA_DDR		= DDRC
.equ AUSGANG_DEMODULATORA_PORT		= PORTC
; AUSGANG (DEMODULATOR-B)						
.equ AUSGANG_DEMODULATORB_PIN_NR	= 1
.equ AUSGANG_DEMODULATORB_DDR		= DDRC
.equ AUSGANG_DEMODULATORB_PORT		= PORTC
; AUSGANG (TEST)								
.equ AUSGANG_TEST_PIN_NR			= 2
.equ AUSGANG_TEST_DDR				= DDRC
.equ AUSGANG_TEST_PORT				= PORTC
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD

; LED-ROT(A)									
.equ LED_ROTA_PIN_NR				= 3
.equ LED_ROTA_DDR					= DDRC
.equ LED_ROTA_PORT					= PORTC
; LED-ROT(B)									
.equ LED_ROTB_PIN_NR				= 4
.equ LED_ROTB_DDR					= DDRC
.equ LED_ROTB_PORT					= PORTC
; LED-ROT(C)									
.equ LED_ROTC_PIN_NR				= 5
.equ LED_ROTC_DDR					= DDRC
.equ LED_ROTC_PORT					= PORTC


; Register										

.def ZONE_A			= R0
.def ZONE_B			= R1
.def ZONE_C			= R2
.def ZONE_D			= R3
.def ZONE_E			= R4
.def ZONE_F			= R5

.def SAMPLING 		= R6
.def SAMPLING_OLD 	= R7
.def SAMPLING_A		= R8
.def SAMPLING_B		= R9
.def INTERRUPTAUFRUF= R12

.def NULL 			= R14
.def VOLL 			= R15

.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19

.def PHASE 				= R20
.def PHASE_HILFSZAEHLER	= R21
.def ZAEHLER			= R22
.def ANTIJITTER			= R24



.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0				

rjmp RESET      	 ; Reset Handler                           			  
rjmp EXT_INT0   ; IRQ0 Handler                      
rjmp INTERRUPT_ERROR ;rjmp EXT_INT1   ; IRQ1 Handler                      
rjmp INTERRUPT_ERROR ;rjmp TIM2_COMP  ; Timer2 Compare Handler            
rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF   ; Timer2 Overflow Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT  ; Timer1 Capture Handler            
rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM1_OVF   ; Timer1 Overflow Handler           
rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF	; Timer0 Overflow Handler             
rjmp INTERRUPT_ERROR ;rjmp SPI_STC    ; SPI Transfer Complete Handler     
rjmp INTERRUPT_ERROR ;rjmp USART_RXC  ; USART RX Complete Handler         
rjmp INTERRUPT_ERROR ;rjmp USART_UDRE ; UDR Empty Handler                 
rjmp INTERRUPT_ERROR ;rjmp USART_TXC  ; USART TX Complete Handler         
rjmp INTERRUPT_ERROR ;rjmp ADC        ; ADC Conversion Complete Handler   
rjmp INTERRUPT_ERROR ;rjmp EE_RDY     ; EEPROM Ready Handler              
rjmp INTERRUPT_ERROR ;rjmp ANA_COMP   ; Analog Comparator Handler         
rjmp INTERRUPT_ERROR ;rjmp TWSI       ; Two-wire Serial Interface Handler 
rjmp INTERRUPT_ERROR ;rjmp SPM_RDY    ; Store Program Memory Ready Handler


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR



RESET:                        
;STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; STARTWERTE										
	clr NULL
	ldi temp,255
	mov VOLL, temp
	clr INTERRUPTAUFRUF
	clr ANTIJITTER
	clr PHASE
	clr PHASE_HILFSZAEHLER
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp	
; PORT LED											
; auf AUSGANG									
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT	
	sbi (LED_ROTA_DDR),(LED_ROTA_PIN_NR)		; ROT(A)
	sbi (LED_ROTB_DDR),(LED_ROTB_PIN_NR)		; ROT(B)
	sbi (LED_ROTC_DDR),(LED_ROTC_PIN_NR)		; ROT(C)
; LEDs an										
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	cbi (LED_ROTA_PORT),(LED_ROTA_PIN_NR)		; ROT(A)an	
	cbi (LED_ROTB_PORT),(LED_ROTB_PIN_NR)		; ROT(B)an	
	cbi (LED_ROTC_PORT),(LED_ROTC_PIN_NR)		; ROT(C)an	
; PORT EINGANG-A									
	cbi (EINGANGA_DDR),(EINGANGA_PIN_NR)		; auf EINGANG	
	sbi (EINGANGA_PORT),(EINGANGA_PIN_NR)		; PULL-UP ein	
; PORT EINGANG-B									
	cbi (EINGANGB_DDR),(EINGANGB_PIN_NR)		; auf EINGANG	
	sbi (EINGANGB_PORT),(EINGANGB_PIN_NR)		; PULL-UP ein	
; PORT AUSGANG DATA										
	sbi (AUSGANG_DATA_DDR),(AUSGANG_DATA_PIN_NR)				; auf AUSGANG	
	cbi (AUSGANG_DATA_PORT),(AUSGANG_DATA_PIN_NR)				; auf LOW		
; PORT AUSGANG TAKT										
	sbi (AUSGANG_TAKT_DDR),(AUSGANG_TAKT_PIN_NR)				; auf AUSGANG	
	cbi (AUSGANG_TAKT_PORT),(AUSGANG_TAKT_PIN_NR)				; auf LOW		
; PORT AUSGANG DEMODULATOR(A)							
	sbi (AUSGANG_DEMODULATORA_DDR) ,(AUSGANG_DEMODULATORA_PIN_NR)	; auf AUSGANG	
	cbi (AUSGANG_DEMODULATORA_PORT),(AUSGANG_DEMODULATORA_PIN_NR)	; auf LOW		
; PORT AUSGANG DEMODULATOR(B)							
	sbi (AUSGANG_DEMODULATORB_DDR) ,(AUSGANG_DEMODULATORB_PIN_NR)	; auf AUSGANG	
	cbi (AUSGANG_DEMODULATORB_PORT),(AUSGANG_DEMODULATORB_PIN_NR)	; auf LOW		
; PORT AUSGANG TEST										
	sbi (AUSGANG_TEST_DDR),(AUSGANG_TEST_PIN_NR)				; auf AUSGANG	
	cbi (AUSGANG_TEST_PORT),(AUSGANG_TEST_PIN_NR)				; auf LOW		
; PORT AUSGANG CTC2										
	sbi (AUSGANG_CTC2_DDR),(AUSGANG_CTC2_PIN_NR)				; CTC2		
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; 	TIMER2_CTC_INITIALISIERUNG						
	rcall TIMER2_CTC_INITIALISIERUNG	
; EXTERNER_INTERUPT_INITIALISIEREN					
	rcall EXTERNER_INTERUPT_INITIALISIEREN
; EXTERNER_INTERRUPT_AKTIVIEREN						
	rcall EXTERNER_INTERRUPT_AKTIVIEREN
; ANFANGSZUSTNDE									
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR					; GRN aus		
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)					; GELB aus		
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)						; ROT  aus		
	cbi (AUSGANG_DATA_PORT),(AUSGANG_DATA_PIN_NR)			; auf LOW		
	cbi (AUSGANG_TAKT_PORT),(AUSGANG_TAKT_PIN_NR)			; auf LOW		
	cbi (AUSGANG_TEST_PORT),(AUSGANG_TEST_PIN_NR)			; auf LOW		
; Interrupts aktivieren								
	sei
	clr INTERRUPTAUFRUF
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall RDS
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "R_DECODER_RDS.asm"
.include "R_DECODER_TIMER.asm"
.include "R_DECODER_INTERRUPT.asm"
.include "R_DECODER_SONSTIGES.asm"
.include "R_DECODER_WAIT_16MHZ.asm"		; 16 MHz	

